/*

	This file contains some work behind the scenes to handle implementation-
	specific details of the demo that have little to do with the library.

	This is something I made quick and dirty.  Following it for decent habits
	is not advised.
*/

////////////////////////////////////////////////////////////////////////////////

//	Set world defaults.
world
	icon_size	= 240
	mob			= /mob/Demo
	turf		= /DemoTurf

////////////////////////////////////////////////////////////////////////////////

mob/Demo
	mouse_opacity	= 0

////////////////////////////////////////////////////////////////////////////////

bgf_Room/Demo
	var
		z
		global
			gNextZ	= 1
			list/gUnusedZs

		DemoHand/handRed
		DemoHand/handBlue

		const/GOAL	= 3

	p_RemoveInterfaceRoom(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		var/client/C	= src.GetClient(Person)
		if (C)
			C.images	-= src.handRed.iPrivate
			C.images	-= src.handBlue.iPrivate

	p_RemovePlayer(Player,AutomatedCall=FALSE)
		.	= ..(Player,AutomatedCall)
		if (.)
			var/DemoHand/hand	= src.GetHand(Player)
			if ( istype(hand) )	hand.SetPlayer(null)

	proc
		AddMagic(client/C)
			if ( !istype(C) )	return
			C.images			-= src.handRed.iPrivate
			C.images			-= src.handBlue.iPrivate
			var/DemoHand/H		= src.GetHand(C.mob)
			if (H)				C.images	+= H.iPrivate

		AnnounceWinner(DemoHand/Hand)
			if ( !istype(Hand) )	return
			var/bgf_RoomHandler/H	= src.bgf_GetHandler()
			src.bgf_Chat("<span class='bgf_admin'>[H.bgf_GetAvatar()] [Hand] is victorious!</span>",FALSE,null,"","",null)

		AssignHands()
			var/list/players		= src.p_GetListOfPlayers()
			if ( !length(players) )	return
			var/bgf_RoomHandler/H	= src.bgf_GetHandler()
			if ( !istype(H) )		return
			src.bgf_Chat("<span class='bgf_admin'>[H.bgf_GetAvatar()] Let the game begin!</span>",FALSE,null,"","",null)
			src.handRed.SetPlayer( H.bgf_GetNameOutput(players[1]) )
			src.AddMagic( src.GetClient(players[1]) )
			if (players.len>=2)
				src.handBlue.SetPlayer( H.bgf_GetNameOutput(players[2]) )
				src.AddMagic( src.GetClient(players[2]) )

		ClaimMap()
			if ( length(src.gUnusedZs) )
				src.z			= src.gUnusedZs[1]
				src.gUnusedZs	-= src.z
			else if (src.gNextZ <= world.maxz)
				src.z	= src.gNextZ
				src.gNextZ++
			if (src.z)	src.ResetMap()

		GetClient(Person)
			var/client/C				= Person
			if ( ismob(Person) )
				var/mob/M				= Person
				C						= M.client
			if ( istype(C,/client) )	return C

		GetHand(Player)
			var/bgf_RoomHandler/H					= src.bgf_GetHandler()
			if (!H)									return null
			var/chatName							= H.bgf_GetNameOutput(Player)
			if ( src.handRed.IsPlayer(chatName) )	return src.handRed
			if ( src.handBlue.IsPlayer(chatName) )	return src.handBlue

		PlaceOnEnter(Person)
			if ( istype(Person,/atom/movable) )
				var/atom/movable/M	= Person
				M.Move(locate(1,1,src.z))

		ResetMap()
			for( var/DemoTurf/T in block(locate(1,1,src.z),locate(world.maxx,world.maxy,src.z)) )
				T.Reset()
			if (src.handRed)	src.handRed.Reset()
			else				src.handRed		= new(locate(1,2,src.z))
			if (src.handBlue)	src.handBlue.Reset()
			else				src.handBlue	= new(locate(3,2,src.z),TRUE)

		ReturnMap()
			if (!src.gUnusedZs)	src.gUnusedZs	= list()
			if (src.z)			src.gUnusedZs	+= src.z

////////////////////////////////////////////////////////////////////////////////

DemoTurf
	parent_type	= /turf

	icon		= 'choices.dmi'

	proc
		Reset()
			src.icon_state				= initial(src.icon_state)
			if (src.y == 1)
				if (src.x == 1)			src.icon_state	= "rock"
				else if (src.x == 2)	src.icon_state	= "paper"
				else					src.icon_state	= "scissors"

////////////////////////////////////////////////////////////////////////////////

DemoHand
	parent_type	= /obj

	icon			= 'handR.dmi'
	mouse_opacity	= 2

	var
		image/scoreOverlay
		image/iPrivate

	New(Loc,IsBlue=FALSE)
		..(Loc)
		if (IsBlue)
			src.icon	= 'handB.dmi'
			src.desc	= "<span class='bgf_name'>\"The Blue Hand\"</span>"
		else
			src.desc	= "<span class='bgf_name'>\"The Red Hand\"</span>"
		src.scoreOverlay			= image('score.dmi',src,"0",src.layer+0.1,0)
		src.scoreOverlay.pixel_y	= 240
		src.overlays				+= src.scoreOverlay
		src.iPrivate				= image(src.icon,src,"",src.layer,0)

	proc
		Compare(DemoHand/Hand)
			if ( !istype(Hand) )		return 0
			switch(src.icon_state)
				if ("rock")
					switch(Hand.icon_state)
						if ("rock")		return 0
						if ("paper")	return -1
						if ("scissors")	return 1
				if ("paper")
					switch(Hand.icon_state)
						if ("rock")		return 1
						if ("paper")	return 0
						if ("scissors")	return -1
				if ("scissors")
					switch(Hand.icon_state)
						if ("rock")		return -1
						if ("paper")	return 1
						if ("scissors")	return 0
			return 0

		Display()
			if (!src.iPrivate.icon_state || (src.name == src.desc))
				src.iPrivate.icon_state	= pick("rock","paper","scissors")
			src.icon_state	= src.iPrivate.icon_state

		Hide()
			src.icon_state			= initial(src.icon_state)
			src.iPrivate.icon_state	= initial(src.iPrivate.icon_state)

		GetScore()
			return text2num(src.scoreOverlay.icon_state)

		Increment()
			src.overlays	-= src.scoreOverlay
			src.scoreOverlay.icon_state	= "[text2num(src.scoreOverlay.icon_state) + 1]"
			src.overlays	+= src.scoreOverlay

		IsPlayer(PlayerName)
			return (PlayerName == src.name)

		Reset()
			src.Hide()
			src.overlays	-= src.scoreOverlay
			src.scoreOverlay.icon_state	= "0"
			src.overlays	+= src.scoreOverlay
			src.name		= src.desc

		SetPlayer(PlayerName)
			if (PlayerName)	src.name	= PlayerName
			else			src.name	= src.desc

		SetState(State)
			src.iPrivate.icon_state	= State

////////////////////////////////////////////////////////////////////////////////

bgf_Phase/Demo

	proc
		DisplayResults()
			var/bgf_Room/Demo/R	= src.bgf_GetRoom()
			if ( !istype(R) )	return
			R.handRed.Display()
			R.handBlue.Display()
			var/result			= R.handRed.Compare(R.handBlue)
			if (result>0)		R.handRed.Increment()
			else if (result<0)	R.handBlue.Increment()

		GetWinner()
			var/bgf_Room/Demo/R	= src.bgf_GetRoom()
			if ( istype(R) )
				if (R.handRed.GetScore() >= R.GOAL)		return R.handRed
				if (R.handBlue.GetScore() >= R.GOAL)	return R.handBlue

		InterpretClick(Player,atom/Clicked,Location,Control,Params)
			if ( !src.ph_IsPlaying(Player) || !istype(Clicked,/DemoTurf) \
				|| !Clicked.icon_state)
				return FALSE
			var/bgf_Room/Demo/R		= src.bgf_GetRoom()
			if ( !istype(R) )		return FALSE
			var/DemoHand/hand		= R.GetHand(Player)
			if (!hand)				return FALSE
			if (Clicked.icon_state)	hand.SetState(Clicked.icon_state)
			return TRUE
