bgf_RoomHandler

	//==========================================================================
	var
		list/bgf_globalDeaf
		list/bgf_globalSpeakers

	//==========================================================================
	//--------------------------------------------------------------------------
	p_AddInterface(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		if ( src.bgf_IsHost(Person) )	src.bgf_AddHostInterface(Person)
		else							src.bgf_RemoveHostInterface(Person)
		src.bgf_motd.motd_DisplayDeveloper(Person)
		src.bgf_motd.motd_DisplayAdministrator(Person)

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		var/myInterface

		if (src.bgf_GetControlChat(Person))
			myInterface	= src.bgf_GetVerbChat(Person)
			C.verbs		-= myInterface
			C.verbs		+= myInterface
		if (src.bgf_GetControlGlobalHear(Person))
			myInterface	= src.bgf_GetVerbGlobalHear(Person)
			C.verbs		-= myInterface
			C.verbs		+= myInterface
		if (src.bgf_GetControlGlobalSpeak())
			myInterface	= src.bgf_GetVerbGlobalSpeak(Person)
			C.verbs		-= myInterface
			C.verbs		+= myInterface

		myInterface	= src.bgf_GetControlCreateRoom(Person)
		if (myInterface)
			var/myInterface2	= src.bgf_GetVerbCreateRoom(Person)
			C.verbs				-= myInterface2
			if ( src.bgf_CanCreateRoom(Person) )
				C.verbs	+= myInterface2
				winset(C,myInterface,"is-disabled=false;")
			else
				winset(C,myInterface,"is-disabled=true;")

	//--------------------------------------------------------------------------
	p_RemoveInterface(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		src.bgf_RemoveHostInterface(Person)

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		var/myInterface

		if (src.bgf_GetControlChat(Person))
			C.verbs	-= src.bgf_GetVerbChat(Person)
		if (src.bgf_GetControlGlobalHear(Person))
			C.verbs	-= src.bgf_GetVerbGlobalHear(Person)
		if (src.bgf_GetControlGlobalSpeak(Person))
			C.verbs	-= src.bgf_GetVerbGlobalSpeak(Person)

		myInterface	= src.bgf_GetControlCreateRoom(Person)
		if (myInterface)
			winset(C,myInterface,"is-disabled=true;")
			myInterface	= src.bgf_GetVerbCreateRoom(Person)
			C.verbs		-= myInterface

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Outputs Message to the bgf_controlChat of Chatters.
		//	If Chatters is not defined, it defaults to all people in all rooms.
		//	If Filter, Message will be filtered.  Prefix and Suffix will not.
		//	Sender is tracked for automated muting purposes.
		//	If Prefix and Suffix are null and not text, the prefix and suffix
		//	procs below will be called.
		//	Returns TRUE on success.
		bgf_Chat(Message="",Filter=TRUE,Sender,Prefix,Suffix,Chatters)
			var/myInterface		= src.bgf_GetControlChat(Sender)
			if (!myInterface)	return FALSE

			if (Filter)		Message	= src.bgf_spamFilter.sf_Filter(Sender,Message)
			if (!Message)	return TRUE

			if (!Prefix && !istext(Prefix))	Prefix	= src.bgf_GetChatPrefix(Sender)
			if (!Suffix && !istext(Suffix))	Suffix	= src.bgf_GetChatSuffix(Sender)
			if (!Chatters)					Chatters	= src.p_GetPeople()

			Chatters		<< output("[Prefix][Message][Suffix]",myInterface)
			return TRUE

		//----------------------------------------------------------------------
		bgf_GetChatPrefix(Person)
			return "<span class='bgf_global'>[src.bgf_GetAvatar(Person)] [src.bgf_GetNameOutput(Person)]: "

		//----------------------------------------------------------------------
		bgf_GetChatSuffix(Person)
			return "</span>"


		//----------------------------------------------------------------------
		//	Procs for handling global communication.
		//----------------------------------------------------------------------
		bgf_GetGlobalChatListeners()
			.										= src.p_GetPeople()
			for(var/P in .)
				if ( !src.bgf_IsHearingGlobal(P) )	.	-= P
		//----------------------------------------------------------------------
		bgf_IsHearingGlobal(Person)
			return !(Person in src.bgf_globalDeaf)
		//----------------------------------------------------------------------
		bgf_IsSpeakingGlobal(Person)
			return (Person in src.bgf_globalSpeakers)
		//----------------------------------------------------------------------
		bgf_SetHearGlobal(Person,On=TRUE)
			var/client/C		= Person
			if ( ismob(Person) )
				var/mob/M		= Person
				C				= M.client
			if ( !istype(C) )	C	= null

			var/myInterface	= src.bgf_GetControlGlobalHear(Person)

			if (On)
				if (src.bgf_globalDeaf)	src.bgf_globalDeaf	-= Person
				if (C && myInterface)	winset(C,myInterface,"is-checked=true;")
				return TRUE

			if (!src.bgf_globalDeaf)	src.bgf_globalDeaf	= list()
			src.bgf_globalDeaf			-= Person
			src.bgf_globalDeaf			+= Person
			if (C && myInterface)		winset(C,myInterface,"is-checked=false;")
			return TRUE
		//----------------------------------------------------------------------
		bgf_SetSpeakGlobal(Person,On=TRUE)
			var/client/C		= Person
			if ( ismob(Person) )
				var/mob/M		= Person
				C				= M.client
			if ( !istype(C) )	C	= null

			var/myInterface	= src.bgf_GetControlGlobalSpeak(Person)

			if (On)
				if (!src.bgf_globalSpeakers)	src.bgf_globalSpeakers	= list()
				src.bgf_globalSpeakers			-= Person
				src.bgf_globalSpeakers			+= Person
				if (C && myInterface)	winset(C,myInterface,"is-checked=true;")
				return TRUE

			if (src.bgf_globalSpeakers)	src.bgf_globalSpeakers	-= Person
			if (C && myInterface)		winset(C,myInterface,"is-checked=false;")
			return TRUE

		//----------------------------------------------------------------------
		//	Procs for the BGF interface.
		bgf_GetControlChat()
			return "bgf_chat"//	output
		bgf_GetControlGlobalHear()
			return "bgf_globalHear"//	checkbox button
		bgf_GetControlGlobalSpeak()
			return "bgf_globalSpeak"//	checkbox button

		bgf_GetVerbChat()
			return /bgf_RoomHandler/verb/bgf_chat
		bgf_GetVerbGlobalHear()
			return /bgf_RoomHandler/verb/bgf_globalhear
		bgf_GetVerbGlobalSpeak()
			return /bgf_RoomHandler/verb/bgf_globalspeak

	//==========================================================================
	verb
		//----------------------------------------------------------------------
		bgf_chat(Blah as text)
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return

			if ( H.bgf_IsSpeakingGlobal(usr) )
				H.bgf_Chat(Blah,TRUE,usr,null,null,H.bgf_GetGlobalChatListeners())
				return

			var/bgf_Room/R	= H.p_Find(usr)
			if (R)			R.bgf_Chat(Blah,TRUE,usr)

		//----------------------------------------------------------------------
		bgf_globalhear()
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return

			var/setting	= !H.bgf_IsHearingGlobal(usr)
			H.bgf_SetHearGlobal(usr,setting)

		//----------------------------------------------------------------------
		bgf_globalspeak()
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return

			var/setting		= !H.bgf_IsSpeakingGlobal(usr)
			H.bgf_SetSpeakGlobal(usr,setting)
			if (setting)	H.bgf_SetHearGlobal(usr,TRUE)
