bgf_RoomHandler

	//==========================================================================
	var
		//	A spam filter for chat.
		bgf_SpamFilter/bgf_spamFilter
		//	Message Of The Day
		bgf_MOTD/bgf_motd

		bgf_phaseTime			= 1//	minutes
		bgf_reconnectTime		= 3//	minutes

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		bgf_GetMOTDType()
			return /bgf_MOTD
		bgf_GetSpamFilterType()
			return /bgf_SpamFilter

		//----------------------------------------------------------------------
		bgf_GetControlHost(Person)
			return "bgf_options_server"//pane
		bgf_GetControlOptions(Person)
			return "bgf_childOptions"//	child
		bgf_GetControlPhaseTime(Person)
			return "bgf_phaseTime"//	button
		bgf_GetControlReconnectTime(Person)
			return "bgf_reconnectTime"//	button

		bgf_GetVerbPhaseTime(Person)
			return /bgf_RoomHandler/verb/bgf_phasetime
		bgf_GetVerbReconnectTime(Person)
			return /bgf_RoomHandler/verb/bgf_reconnecttime


		//----------------------------------------------------------------------
		bgf_GetTicksPerMinute()
			//	1 minute takes roughly 600 ticks when world.tick_lag is 1.
			if (!world.tick_lag)	return 0
			return 600/world.tick_lag

		//----------------------------------------------------------------------
		//	Returns whether or not Person is the host.
		//	By default, it just does a ckey() comparison with world.host.
		bgf_IsHost(Person)
			if ( ismob(Person) )
				var/mob/M	= Person
				Person		= M.key
			else if ( istype(Person,/client) )
				var/client/C	= Person
				Person			= C.key

			return ( ckey(Person) == ckey(world.host) )

		//----------------------------------------------------------------------
		//	Adds host controls such as those managing spam and the MOTD.
		bgf_AddHostInterface(Person)
			var/client/C				= Person
			if ( ismob(Person) )
				var/mob/M				= Person
				C						= M.client
			if ( !istype(C,/client) )	return FALSE

			var
				myInterface
				myInterface2

			myInterface		= src.bgf_GetControlHost(Person)
			myInterface2	= src.bgf_GetControlOptions(Person)
			if (myInterface && myInterface2)
				winset(Person,myInterface2,"left=[myInterface];")

			myInterface	= src.bgf_GetControlPhaseTime()
			if (myInterface)
				Person	<< output(src.bgf_phaseTime,myInterface)
				myInterface	= src.bgf_GetVerbPhaseTime(Person)
				if (myInterface)
					C.verbs	-= myInterface
					C.verbs	+= myInterface

			myInterface	= src.bgf_GetControlReconnectTime()
			if (myInterface)
				Person	<< output(src.bgf_reconnectTime,myInterface)
				myInterface	= src.bgf_GetVerbReconnectTime(Person)
				if (myInterface)
					C.verbs	-= myInterface
					C.verbs	+= myInterface

			src.bgf_spamFilter.sf_AddInterface(C)
			src.bgf_motd.motd_AddInterface(C)

			return TRUE

		//----------------------------------------------------------------------
		//	Removes host controls such as those managing spam and the MOTD.
		bgf_RemoveHostInterface(Person)
			var/client/C				= Person
			if ( ismob(Person) )
				var/mob/M				= Person
				C						= M.client
			if ( !istype(C,/client) )	return FALSE

			var
				myInterface
				myInterface2

			myInterface		= src.bgf_GetControlHost(Person)
			myInterface2	= src.bgf_GetControlOptions(Person)
			if (myInterface && myInterface2)
				winset(Person,myInterface,"left=;")

			myInterface			= src.bgf_GetVerbPhaseTime(Person)
			if (myInterface)	C.verbs	-= myInterface
			myInterface			= src.bgf_GetVerbReconnectTime(Person)
			if (myInterface)	C.verbs	-= myInterface

			src.bgf_spamFilter.sf_RemoveInterface(C)
			src.bgf_motd.motd_RemoveInterface(C)

			return TRUE

	//==========================================================================
	verb
		//----------------------------------------------------------------------
		bgf_phasetime()
			if (!usr)				return
			var/bgf_RoomHandler/H	= usr.bgf_GetRoomHandler()
			if ( !istype(H) )		return

			var/time			= input(usr,"How many minutes will phases be ended in when enough votes pass?","Phase Time",H.bgf_phaseTime)
			if ( !isnum(time) )	return

			H.bgf_phaseTime		= time
			var/myInterface		= src.bgf_GetControlPhaseTime()
			if (myInterface)	usr	<< output(H.bgf_phaseTime,myInterface)

		//----------------------------------------------------------------------
		bgf_reconnecttime()
			if (!usr)				return
			var/bgf_RoomHandler/H	= usr.bgf_GetRoomHandler()
			if ( !istype(H) )		return

			var/time			= input(usr,"How many minutes do disconnected players have to reconnect?","Reconnect Time",H.bgf_reconnectTime)
			if ( !isnum(time) )	return

			H.bgf_reconnectTime	= time
			var/myInterface		= H.bgf_GetControlReconnectTime()
			if (myInterface)	usr	<< output(H.bgf_reconnectTime,myInterface)
