bgf_MOTD
	parent_type		= /motd_MOTD

	//==========================================================================
	//	Keep track of the handler so the display can be updated.

	var/bgf_RoomHandler/bgf_handler

	New(bgf_RoomHandler/Handler)
		if ( istype(Handler) )	src.bgf_handler	= Handler
		..()

	Del()
		src.bgf_handler	= null
		..()

	//==========================================================================
	motd_out_admin	= "bgf_motd"

	//==========================================================================
	//	My MOTD library separates developer and administrator messages.
	//	However, I find it handy to display them in one place.
	//	This interface sends them to an output control.
	//	Sending null will clear the control, but we'll want to send the messages
	//	at the same time to avoid clearing one while posting another.
	//	Here are some prefix and suffix procs to send simultaneously.
	proc
		bgf_GetAdminPrefix(Viewer)
		bgf_GetAdminSuffix(Viewer)

	motd_DisplayAdministrator(Viewer)
		if (!src.motd_out_admin)	return

		Viewer	<< output(null,src.motd_out_admin)

		var/more	= src.bgf_GetAdminPrefix(Viewer)
		if (more)	Viewer	<< output(more,src.motd_out_admin)

		//	Making it clear who the host is can also be handy.
		if ( world.host && (world.host != "Guest") )
			if (src.motd_admin)
				Viewer	<< output("Your host, <strong>[world.host]</strong>, has the following message:\n",src.motd_out_admin)
				Viewer	<< output(src.motd_admin,src.motd_out_admin)
			else
				Viewer	<< output("Your host is <strong>[world.host]</strong>.",src.motd_out_admin)
		else if (src.motd_admin)
			Viewer	<< output(src.motd_admin,src.motd_out_admin)

		more		= src.bgf_GetAdminSuffix(Viewer)
		if (more)	Viewer	<< output(more,src.motd_out_admin)

	//==========================================================================
	//	Update the display after changes.
	motd_Set(MOTD)
		.							= ..(MOTD)
		if (. && src.bgf_handler)	src.motd_DisplayAdministrator(src.bgf_handler.p_GetPeople())
