bgf_Room

	//==========================================================================
	//--------------------------------------------------------------------------
	//	Note: Ender will equal the room itself if the room is being deleted.
	p_Ended(Ender,AutomatedCall=FALSE)
		.	= ..(Ender,AutomatedCall)

		//	Clear the phase handler.
		if ( istype(src.bgf_phases) )	src.bgf_phases.ph_Clear()
		//	Display people in the room.
		src.p_DisplayPeopleToAll(AutomatedCall)
		//	Display updated status in room handler's list.
		if (src.bgf_handler)	src.bgf_handler.bgf_UpdateRoomDisplay(src)

	//--------------------------------------------------------------------------
	p_Started(Starter,AutomatedCall=FALSE)
		.	= ..(Starter,AutomatedCall)

		//	Display people in the room.
		src.p_DisplayPeopleToAll(AutomatedCall)
		//	Display updated status in room handler's list.
		if (src.bgf_handler)	src.bgf_handler.bgf_UpdateRoomDisplay(src)

		//	Add players to the phase handler and start the first phase.
		if ( istype(src.bgf_phases) )
			for(var/P in src.p_GetListOfPlayers())
				src.bgf_phases.ph_AddPlayer(P)
			src.bgf_phases.ph_NextPhase()

	//--------------------------------------------------------------------------
	//	by default, StartEndHandlers require a minimum of two players.
	//	We'll set the default to 1 to be friendly to single player games.
	p_GetMinPlayers()
		return 1

	//==========================================================================
	//--------------------------------------------------------------------------
	p_AddInterfaceRoom(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		if (src.bgf_GetControlJoinQuit(Person))
			var/myInterface	= src.bgf_GetVerbJoinQuit(Person)
			C.verbs			-= myInterface
			C.verbs			+= myInterface

		src.p_DisplayPeopleToViewer(Person)

	//--------------------------------------------------------------------------
	p_AddInterfacePlayer(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		var
			list/L		= list()
			myInterface

		myInterface			= src.bgf_GetControlJoinQuit(Person)
		if (myInterface)	L["[myInterface].text"]	= "Quit"

		myInterface							= src.bgf_GetControlStart(Person)
		if (myInterface)
			L["[myInterface].is-disabled"]	= "true"
			C.verbs							-= src.bgf_GetVerbStart(Person)

		winset(Person,null,list2params(L))

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_AddInterface(Person)

	//--------------------------------------------------------------------------
	p_AddInterfaceSpectator(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		var
			list/L		= list()
			myInterface

		myInterface			= src.bgf_GetControlJoinQuit(Person)
		if (myInterface)	L["[myInterface].text"]	= "Join"

		myInterface							= src.bgf_GetControlStart(Person)
		if (myInterface)
			L["[myInterface].is-disabled"]	= "true"
			C.verbs							-= src.bgf_GetVerbStart(Person)

		winset(Person,null,list2params(L))

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_AddInterface(Person)

	//--------------------------------------------------------------------------
	p_AddInterfaceWaiter(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		var
			list/L		= list()
			myInterface

		myInterface			= src.bgf_GetControlJoinQuit(Person)
		if (myInterface)	L["[myInterface].text"]	= "Quit"

		myInterface							= src.bgf_GetControlStart(Person)
		if (myInterface)
			L["[myInterface].is-disabled"]	= "false"
			myInterface						= src.bgf_GetVerbStart(Person)
			C.verbs							-= myInterface
			C.verbs							+= myInterface

		winset(Person,null,list2params(L))

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_AddInterface(Person)

	//--------------------------------------------------------------------------
	p_DisplayPeopleToViewer(Viewer)
		.						= ..(Viewer)
		var/roomies				= src.bgf_GetControlRoomies(Viewer)
		if (!(.) || !roomies)	return .

		var
			list/players	= src.p_GetListOfPlayers()
			list/waiters	= src.p_GetListOfWaiters()
			row				= 0

		if (players.len)	row	+= 1 + players.len
		if (waiters.len)	row	+= 1 + waiters.len
		winset(Viewer,null,"[roomies].cells=2x[row];")

		var
			P
			toggle	= TRUE
		row			= 1

		if (players.len)
			Viewer	<< output("<span class='bgf_playing'>Playing:</span>","[roomies]:1,[row]")
			Viewer	<< output("<span class='bgf_playing'>[players.len]</span>","[roomies]:2,[row]")
			row++
			for(P in players)
				toggle	= !toggle
				if (toggle)
					Viewer	<< output(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_playing"),"[roomies]:1,[row]")
					Viewer	<< output(src.bgf_handler.bgf_GetNameOutput(P,"bgf_playing"),"[roomies]:2,[row]")
				else
					Viewer	<< output(src.bgf_handler.bgf_GetNameOutput(P,"bgf_playing"),"[roomies]:1,[row]")
					Viewer	<< output(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_playing"),"[roomies]:2,[row]")
				row++

		if (waiters.len)
			Viewer	<< output("<span class='bgf_waiting'>Waiting:</span>","[roomies]:1,[row]")
			Viewer	<< output("<span class='bgf_waiting'>[players.len]</span>","[roomies]:2,[row]")
			row++
			for(P in waiters)
				toggle	= !toggle
				if (toggle)
					Viewer	<< output(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_waiting"),"[roomies]:1,[row]")
					Viewer	<< output(src.bgf_handler.bgf_GetNameOutput(P,"bgf_waiting"),"[roomies]:2,[row]")
				else
					Viewer	<< output(src.bgf_handler.bgf_GetNameOutput(P,"bgf_waiting"),"[roomies]:1,[row]")
					Viewer	<< output(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_waiting"),"[roomies]:2,[row]")
				row++

	//--------------------------------------------------------------------------
	p_DisplayPeopleToAll(AutomatedCall=FALSE)
		var/roomies		= src.bgf_GetControlRoomies()
		if (!roomies)	return ..(AutomatedCall)

		var
			list/players	= src.p_GetListOfPlayers()
			list/waiters	= src.p_GetListOfWaiters()
			row				= 0

		if (players.len)	row	+= 1 + players.len
		if (waiters.len)	row	+= 1 + waiters.len
		src.p_WinsetAll(null,"[roomies].cells=2x[row];")

		var
			P
			toggle	= TRUE
		row			= 1

		if (players.len)
			src.p_OutputAll("<span class='bgf_playing'>Playing:</span>","[roomies]:1,[row]")
			src.p_OutputAll("<span class='bgf_playing'>[players.len]</span>","[roomies]:2,[row]")
			row++
			for(P in players)
				toggle	= !toggle
				if (toggle)
					src.p_OutputAll(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_playing"),"[roomies]:1,[row]")
					src.p_OutputAll(src.bgf_handler.bgf_GetNameOutput(P,"bgf_playing"),"[roomies]:2,[row]")
				else
					src.p_OutputAll(src.bgf_handler.bgf_GetNameOutput(P,"bgf_playing"),"[roomies]:1,[row]")
					src.p_OutputAll(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_playing"),"[roomies]:2,[row]")
				row++

		if (waiters.len)
			src.p_OutputAll("<span class='bgf_waiting'>Waiting:</span>","[roomies]:1,[row]")
			src.p_OutputAll("<span class='bgf_waiting'>[waiters.len]</span>","[roomies]:2,[row]")
			row++
			for(P in waiters)
				toggle	= !toggle
				if (toggle)
					src.p_OutputAll(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_waiting"),"[roomies]:1,[row]")
					src.p_OutputAll(src.bgf_handler.bgf_GetNameOutput(P,"bgf_waiting"),"[roomies]:2,[row]")
				else
					src.p_OutputAll(src.bgf_handler.bgf_GetNameOutput(P,"bgf_waiting"),"[roomies]:1,[row]")
					src.p_OutputAll(src.bgf_handler.bgf_GetAvatar(P,FALSE,"bgf_waiting"),"[roomies]:2,[row]")
				row++

	//--------------------------------------------------------------------------
	p_RemoveInterfaceRoom(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		var/client/C		= Person
		if ( ismob(Person) )
			var/mob/M		= Person
			C				= M.client
		if ( !istype(C) )	return .

		if (src.bgf_GetControlJoinQuit())	C.verbs	-= src.bgf_GetVerbJoinQuit()
		if (src.bgf_GetControlStart())		C.verbs	-= src.bgf_GetVerbStart()

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_RemoveInterface(Person)

	//--------------------------------------------------------------------------
	p_RemoveInterfacePlayer(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_RemoveInterface(Person)

	//--------------------------------------------------------------------------
	p_RemoveInterfaceSpectator(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_RemoveInterface(Person)

	//--------------------------------------------------------------------------
	p_RemoveInterfaceWaiter(Person)
		.			= ..(Person)
		if ( !(.) )	return .

		if ( istype(src.bgf_phases) )
			var/bgf_Phase/phase	= src.bgf_phases.ph_GetCurrentPhase()
			if (phase)			phase.ph_RemoveInterface(Person)

	//--------------------------------------------------------------------------
	p_RemovePlayer(Player,AutomatedCall=FALSE)
		.	= ..(Player,AutomatedCall)
		if (. && src.bgf_phases && !src.p_IsEnding())
			src.bgf_phases.ph_RemovePlayer(Player)

	//==========================================================================
	proc
		//-----------------------------------------------------------------------
		bgf_GetControlJoinQuit(Person)
			return "bgf_joinQuit"//	button
		bgf_GetControlRoomies(Person)
			return "bgf_roomies"//	grid
		bgf_GetControlStart(Person)
			return "bgf_startGame"//	button

		//-----------------------------------------------------------------------
		bgf_GetVerbJoinQuit()
			return /bgf_Room/verb/bgf_joinquit
		bgf_GetVerbStart()
			return /bgf_Room/verb/bgf_start

	//==========================================================================
	verb
		//-----------------------------------------------------------------------
		bgf_joinquit()
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return
			var/bgf_Room/R				= H.p_Find(usr)
			if (!R)						return

			if ( !R.p_IsSpectating(usr) )	R.p_AddSpectator(usr)
			else							R.p_AddWaiter(usr)

		//-----------------------------------------------------------------------
		bgf_start()
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return
			var/bgf_Room/R				= H.p_Find(usr)
			if (!R)						return

			R.p_Start(usr)
