bgf_Phase
	parent_type	= /ph_Phase

	//==========================================================================
	//--------------------------------------------------------------------------
	ph_AddInterface(Candidate)
		var/client/C		= src.bgf_CanUseInterface(Candidate)
		if ( !istype(C) )	return FALSE

		C.verbs	-= /bgf_Phase/verb/bgf_vote

		var/verbConfirm	= src.bgf_GetVerbConfirm(Candidate)
		C.verbs			-= verbConfirm

		var/controlCV	= src.bgf_GetControlConfirmVote(Candidate)
		if (!controlCV)	return TRUE
		.				= TRUE

		var/bgf_PhaseHandler/H	= src.ph_GetHandler()
		if ( !istype(H) || !istype(H.bgf_room,/p_Room) )	return .

		if ( H.bgf_room.p_IsPlaying(Candidate) )
			winset(C,controlCV,"command='bgf-confirm';text='End Turn';is-disabled=false;is-visible=true;")
			C.verbs	+= verbConfirm
		else
			winset(C,controlCV,"command='bgf-confirm';text='End Turn';is-disabled=true;is-visible=false;")

	//--------------------------------------------------------------------------
	ph_EndBody()
		.	= ..()
		var/bgf_PhaseHandler/H	= src.ph_GetHandler()
		if ( !istype(H) )		return

		//	Reset the timer.
		//	Players could have quit between phases so reset the voters as well.
		if ( istype(H.bgf_timer) )	H.bgf_timer.timer_Clear()
		if ( istype(H.bgf_votes) )	H.bgf_votes.sidv_ClearVoters()

		//	Remove the interface from everyone in the room.
		var/bgf_Room/R						= src.bgf_GetRoom()
		if ( !istype(R) )					return .
		for(var/P in R.p_GetListOfAll())	src.ph_RemoveInterface(P)

	//--------------------------------------------------------------------------
	ph_RemoveInterface(Candidate)
		var/client/C		= src.bgf_CanUseInterface(Candidate)
		if ( !istype(C) )	return FALSE

		C.verbs	-= src.bgf_GetVerbConfirm(Candidate)

		var/verbVote	= src.bgf_GetVerbVote(Candidate)
		C.verbs			-= verbVote

		var/controlCV	= src.bgf_GetControlConfirmVote(Candidate)
		if (!controlCV)	return TRUE
		.				= TRUE

		var/bgf_Room/R		= src.bgf_GetRoom()
		if ( !istype(R) )	return .

		if ( R.p_IsPlaying(Candidate) && !src.ph_IsEnding() )
			C.verbs	+= verbVote
			winset(C,controlCV,"command='bgf-vote';text='Add Timer';is-disabled=false;is-visible=true;")
		else
			winset(C,controlCV,"command='bgf-confirm';text='End Turn';is-disabled=true;is-visible=false;")


	//--------------------------------------------------------------------------
	ph_StartBody()
		.	= ..()

		var/bgf_PhaseHandler/H	= src.ph_GetHandler()
		if ( !istype(H) )		return

		var/P

		for(P in src.ph_GetPlayers())	H.bgf_votes.sidv_AddVoter(P)

		//	Add the interface to everyone in the room.
		var/bgf_Room/R					= src.bgf_GetRoom()
		if ( !istype(R) )				return .
		for(P in R.p_GetListOfAll())	src.ph_AddInterface(P)

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	The parent phase restricts interfaces to people playing.
		//	I'm redefining it to allow any person in the room.
		//	This will return Candidate's client if it can use an interface.
		bgf_CanUseInterface(Candidate)
			var/client/C				= Candidate
			if ( ismob(Candidate) )
				var/mob/M				= Candidate
				C						= M.client
			if ( !istype(C,/client) )	return

			var/bgf_PhaseHandler/H	= src.ph_GetHandler()
			if ( !istype(H) || !istype(H.bgf_room,/p_Room) )	return

			if ( H.bgf_room.p_IsListed(Candidate) )	return C

		//----------------------------------------------------------------------
		bgf_GetControlConfirmVote(Person)
			return "bgf_confirmVote"//	button
		//----------------------------------------------------------------------
		bgf_GetVerbConfirm(Person)
			return /bgf_Phase/verb/bgf_confirm
		//----------------------------------------------------------------------
		bgf_GetVerbVote(Person)
			return /bgf_Phase/verb/bgf_vote

		//----------------------------------------------------------------------
		bgf_GetNextPhaseType()
			return null

		//----------------------------------------------------------------------
		bgf_GetRoom()
			var/bgf_PhaseHandler/H	= src.ph_GetHandler()
			if ( istype(H) )		return H.bgf_GetRoom()

		//----------------------------------------------------------------------
		bgf_CanConfirm(Candidate)
			return src.ph_IsPlaying(Candidate)
		//----------------------------------------------------------------------
		bgf_Confirm(Candidate)
			if ( !src.bgf_CanConfirm(Candidate) )	return FALSE
			return src.ph_RemovePlayer(Candidate,TRUE)

	//==========================================================================
	verb
		//----------------------------------------------------------------------
		bgf_confirm()
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return
			var/bgf_Room/R				= H.p_Find(usr)
			if (!R)						return

			var/bgf_Phase/phase			= R.bgf_phases.ph_GetCurrentPhase()
			if ( istype(phase) )		phase.bgf_Confirm(usr)

		//----------------------------------------------------------------------
		bgf_vote()
			if (!usr || !usr.client)	return
			var/bgf_RoomHandler/H		= usr.bgf_GetRoomHandler()
			if ( !istype(H) )			return

			var/bgf_Room/R										= H.p_Find(usr)
			if (!R || !R.bgf_phases || !R.bgf_phases.bgf_votes)	return

			usr.verbs	+= /bgf_Phase/verb/bgf_vote

			var/bgf_Phase/phase	= R.bgf_phases.ph_GetCurrentPhase()
			if (istype(phase) && phase.bgf_GetControlConfirmVote())
				winset(usr,phase.bgf_GetControlConfirmVote(),"command='bgf-confirm';text='End Turn';is-disabled=true;")

			R.bgf_phases.bgf_votes.sidv_Vote(usr)
