bgf_PhaseHandler

	//==========================================================================
	parent_type	= /ph_PhaseHandler

	//==========================================================================
	var
		bgf_Room/bgf_room

		//	Votes to decide when a timer should be set to end the current phase.
		bgf_PhaseEndingVotes/bgf_votes
		//	The timer that ends the phase.
		bgf_PhaseTimer/bgf_timer

	//==========================================================================
	//--------------------------------------------------------------------------
	New(bgf_Room/Room)
		..()
		if ( istype(Room) )	src.bgf_room	= Room
		var/myType			= src.bgf_GetTimerType()
		if (myType)			src.bgf_timer	= new myType(src)
		myType				= src.bgf_GetVotesType()
		if (myType)			src.bgf_votes	= new myType(src)

	//--------------------------------------------------------------------------
	Del()
		src.bgf_room	= null
		..()

	//--------------------------------------------------------------------------
	ph_GetNextPhase()
		if (!src.bgf_room || src.bgf_room.p_IsEnding() )	return null
		if (!src.bgf_room.p_IsStarting() && !src.bgf_room.p_IsInProgress() )
			return null

		var/bgf_Phase/current		= src.ph_GetCurrentPhase()
		if (current)
			current					= current.bgf_GetNextPhaseType()
			if ( ispath(current) )	return new current(src)
			return null

		current					= src.bgf_GetStartingPhaseType()
		if ( ispath(current) )	return new current(src)

		return null

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	Redefining this proc is not advised.
		bgf_GetRoom()
			return src.bgf_room

		//----------------------------------------------------------------------
		//	Called when there is no phase to reference for the next.
		bgf_GetStartingPhaseType()
			return /bgf_Phase

		//----------------------------------------------------------------------
		bgf_GetTimerType()
			return /bgf_PhaseTimer

		//----------------------------------------------------------------------
		bgf_GetVotesType()
			return /bgf_PhaseEndingVotes
