bgf_PhaseTimer
	parent_type	= /timer_Timer

	//==========================================================================
	var/bgf_PhaseHandler/bgf_phases

	New(bgf_PhaseHandler/Handler)
		..()
		if ( istype(Handler) )	src.bgf_phases	= Handler

	Del()
		src.bgf_phases	= null
		..()

	//==========================================================================
	//	If the game is in progress and the phases are not transitioning,
	//	then begin the next phase.
	timer_Ended()
		if (!src.bgf_phases || !src.bgf_phases.bgf_room)	return ..()
		if ( src.bgf_phases.bgf_room.p_IsInProgress() && \
			!src.bgf_phases.bgf_room.p_IsEnding() && \
			!src.bgf_phases.bgf_room.p_IsStarting() )
			src.bgf_phases.ph_NextPhase(TRUE)
		return ..()

	//==========================================================================
	timer_Start(Time)
		if (!isnum(Time) && src.bgf_phases && src.bgf_phases.bgf_room && src.bgf_phases.bgf_room.bgf_handler)
			Time	= src.bgf_phases.bgf_room.bgf_handler.bgf_phaseTime
			Time	*= src.bgf_phases.bgf_room.bgf_handler.bgf_GetTicksPerMinute()
		src.bgf_AnnounceStart(Time)
		return ..(Time)

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	By default, this sends a message to the chat output.  Spam is bad.
		//	You can do better in your own interface.
		bgf_AnnounceStart(Time)
			if (!src.bgf_phases)	return

			var/bgf_Room/R		= src.bgf_phases.bgf_GetRoom()
			if ( !istype(R) )	return

			var/bgf_RoomHandler/RH	= R.bgf_GetHandler()
			if ( !istype(RH) )		return

			RH								= RH.bgf_GetTicksPerMinute()
			if ( !isnum(RH) || (RH<=0) )	return

			Time	= max(0,Time/RH)
			R.bgf_Chat("<span class='bgf_admin'>The phase will end in [Time] minute\s.</span>",Filter=FALSE)
