/*
////////////////////////////////////////////////////////////////////////////////

Board Game Framework

Created by ACWraith (aka Andre La Barre)

////////////////////////////////////////////////////////////////////////////////

LICENSE:
	You may use this library in your project whether it is for profit or not.
	A mention in the credits would be appreciated.

////////////////////////////////////////////////////////////////////////////////

I have created multiple board games over the years and created multiple
libraries to make it easier.  This library ties them together with an interface
that can be overwritten.

	*	Multiple game rooms can run on one server.
	*	Chat can be filtered.
	*	An adjustable Message Of The Day can be displayed.
	*	Turns can be broken into phases.  Each turn is simultaneous by default.
	*	Players can vote to add timers.
	*	The interface can be overwritten piece by piece.

Normally, I'd fill this space with a long list of procs for easy reference.
However, this library is rather large.  It's especially so if you're not used to
working with the parent libraries.  Instead, I suggest the following steps.

	1.  Read the demo.dm file located in the Demo folder.  It uses the default
		settings.  The library handles a lot of things for you.

	2.	If you don't mind using the default interface, copy and paste the demo's
		prototype.dmf skin file into your own project.  At the time of this
		writing, BYOND has no method of inheriting skin files from libraries.

	3.	The Handler and Room folders both contain _reference.dm files.  Be sure
		to pay attention to the procs with asterisks (*) as you will likely want
		to redefine them.

	4.	Study my Phase library.  (The link is below.)  Phases are what define
		the bulk of the game-specific content this library will handle.

	*	For more options, read those _reference.dm files more thoroughly and
		skim through the help files of the parent libraries listed below.

////////////////////////////////////////////////////////////////////////////////

The following libraries are included.  Some include other libraries themselves.

	ACWraith.MOTD
		http://www.byond.com/developer/ACWraith/MOTD

	ACWraith.MultipleGameRooms
		http://www.byond.com/developer/ACWraith/MultipleGameRooms

	ACWraith.Phase
		http://www.byond.com/developer/ACWraith/Phase

	ACWraith.SharedIDVote
		http://www.byond.com/developer/ACWraith/SharedIDVote

	ACWraith.SpamFilter
		http://www.byond.com/developer/ACWraith/SpamFilter

	ACWraith.Timer
		http://www.byond.com/developer/ACWraith/Timer

*/